
											 
'-------------------------------------------------------------------------------
'--- PIC related                                                             ---
'-------------------------------------------------------------------------------
OPTIMISER_LEVEL = 0

Device = 12F675 			    
XTAL = 4
Config INTRC_OSC_NOCLKOUT,WDT_OFF,PWRTE_ON,CP_OFF,CPD_OFF,MCLRE_OFF
OSCCAL = $48

ADCON0 = %00000000 ' Set analog inputs on PORTB off 
ANSEL = %00000000 ' select no analog inputs
CMCON = %00000111 ' disable comparators 

ALL_DIGITAL = true	
Output GPIO.0
Output GPIO.1
Output GPIO.2
Input GPIO.3

Dim A1 As Bit
Dim A2 As Bit
Dim B1 As Bit
Dim B2 As Bit
Dim C1 As Bit
Dim C2 As Bit

Dim V As Byte
Dim W As Byte
Dim X As Byte
Dim Y As Byte
Dim Z As Byte

V=0
W=0
X=0
Y=0
Z=0

Main:
    X = X + 1
    If X > 8 Then X = 1
    Select Case X
        Case 1
            GPIO.0 = 1
            GPIO.1 = 0
            GPIO.2 = 0        
        Case 2
            GPIO.0 = 0
            GPIO.1 = 1
            GPIO.2 = 0        
        Case 3
            GPIO.0 = 0
            GPIO.1 = 0
            GPIO.2 = 1                
        Case 4
            GPIO.0 = 1
            GPIO.1 = 1
            GPIO.2 = 0                
        Case 5
            GPIO.0 = 1
            GPIO.1 = 0
            GPIO.2 = 1                
        Case 6
            GPIO.0 = 0
            GPIO.1 = 1
            GPIO.2 = 1                
        Case 7
            GPIO.0 = 1
            GPIO.1 = 1
            GPIO.2 = 1                    
    End Select        
    GoSub WaitKey
GoTo Main:	

WaitKey:
    Repeat 
        If X = 8 Then GoSub FadeColors
    Until GPIO.3 = 1
    Repeat 
        'If X = 8 Then GoSub FadeColors
    Until GPIO.3 = 0
Return

'--- create routine to fade trough colors ;-) ---
FadeColors:
    Y = Y + 1
    If Y > 8 Then Y = 1
    If Y = 1 Then
        V = 8
    Else
        V = Y - 1
    EndIf
    GoSub SetColors1:
    GoSub SetColors2:
        
    For Z = 1 To 200
        For W = 1 To Z    
            GPIO.0 = A1
            GPIO.1 = B1
            GPIO.2 = C1
            If GPIO.3 = 1 Then Return
        Next W
        For W = Z To 200
            GPIO.0 = A2
            GPIO.1 = B2
            GPIO.2 = C2
            If GPIO.3 = 1 Then Return
        Next W
    Next Z
Return

SetColors1:
    Select Case Y
        Case 1
            A1 = 1
            B1 = 1
            C1 = 1                        
        Case 2
            A1 = 0
            B1 = 1
            C1 = 0        
        Case 3
            A1 = 1
            B1 = 0
            C1 = 1        
        Case 4
            A1 = 0
            B1 = 1
            C1 = 1                
        Case 5
            A1 = 1
            B1 = 1
            C1 = 0                
        Case 6
            A1 = 0
            B1 = 0
            C1 = 1                
        Case 7
            A1 = 1
            B1 = 0
            C1 = 0                
    End Select
Return

SetColors2:
    Select Case V
        Case 1
            A2 = 1
            B2 = 1
            C2 = 1                        
        Case 2
            A2 = 0
            B2 = 1
            C2 = 0        
        Case 3
            A2 = 1
            B2 = 0
            C2 = 1        
        Case 4
            A2 = 0
            B2 = 1
            C2 = 1                
        Case 5
            A2 = 1
            B2 = 1
            C2 = 0                
        Case 6
            A2 = 0
            B2 = 0
            C2 = 1                
        Case 7
            A2 = 1
            B2 = 0
            C2 = 0                
    End Select
Return
